C*$* NO CONCURRENTIZE
      SUBROUTINE ENERGY
C wrapper calling energy routines
C CDS 10/19/01      
      IMPLICIT NONE
      include 'psf.fcm'
      include 'cnst.fcm'
      include 'ener.fcm'
      include 'deriv.fcm'
      include 'timer.fcm'

c     ------------------------------------------------------------------
c     FANTALIN stuff (2003)
c
      double precision fenergtot
      common /fenerg/fenergtot
c     ------------------------------------------------------------------

C parameters
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C
      DOUBLE COMPLEX DCVAL
      DOUBLE PRECISION TOTAL
      INTEGER I, NDIM
C
C
C initialization
      DO I=1,NENERT
      RENR(I)=ZERO
      END DO
      DO I=1,NATOM
      DX(I)=ZERO
      DY(I)=ZERO
      DZ(I)=ZERO
      END DO
C
      CALL XPLOR_ENERGY()
C
      IF (TIMER.EQ.1) CALL DSPCPU(' ENERGY: after XPLOR terms ')
C
C declare active energy terms
      DO I = 1,NENERT
      IF ( QENER(I) ) THEN
      CALL DECLAR( ANER(I), 'DP', ' ', DCVAL, RENR(I) )
      END IF
      END DO
C
C compute total energy, and put in the accumulation slot SSENER
      TOTAL=ZERO
      DO I=1,NENERT
      IF (QENER(I)) TOTAL=TOTAL+RENR(I)
      END DO
      RENR(SSENER)=TOTAL
      CALL DECLAR( ANER(SSENER), 'DP', ' ', DCVAL, RENR(SSENER) )
C
c     ------------------------------------------------------------------
c     FANTALIN stuff (2003)
c
      fenergtot=total
c     ------------------------------------------------------------------

C compute gradient and put in the accumulation slot SSSD
      TOTAL=ZERO
      NDIM=0
      DO I=1,NATOM
      TOTAL=TOTAL+DX(I)*DX(I)+DY(I)*DY(I)+DZ(I)*DZ(I)
      NDIM=NDIM+3
      END DO
      IF (NDIM.GT.0) TOTAL=SQRT(TOTAL/NDIM)
      RENR(SSSD)=TOTAL
      CALL DECLAR( ANER(SSSD), 'DP', ' ', DCVAL, RENR(SSSD) )
C
C perturbation
      IF (QPERT) THEN
      CALL DECLAR( ANER(SSPERT), 'DP', ' ', DCVAL, RENR(SSPERT) )
      ENDIF
      RETURN
      END
      
      SUBROUTINE XPLOR_ENERGY
C
C Front-end routine for various partial energy routines
C
C Author: Axel T. Brunger
C =======================
C
C modifications to support multiple double selections 
C Thomas Simonson, June 89
C modifications to support Generalized Born
C Thomas Simonson, July 1998, July 2000, May 2002
C
      IMPLICIT NONE
C input/output
      INCLUDE  'psf.fcm'
      INCLUDE  'heap.fcm'
      INCLUDE  'cnst.fcm'
      INCLUDE  'consta.fcm'
      INCLUDE  'ener.fcm'
      INCLUDE  'param.fcm'
      INCLUDE  'ace.fcm'
      INCLUDE  'timer.fcm'
      INCLUDE  'funct.fcm'
      INCLUDE  'comand.fcm'
      INCLUDE  'nbonds.fcm'
C scripting interface
      DOUBLE PRECISION SCRIPTING_ENERGY
C local
      INTEGER I, N, NNDSELE
      DOUBLE PRECISION TOTAL
      DOUBLE COMPLEX DCVAL
      DOUBLE COMPLEX EDUMMY
C parameters
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
C begin
      IF (TIMER.GT.0) CALL DSPCPU(' XPLOR_ENERGY: at entry ')
C
C 
C Scripting energy is ALWAYS CALLED,
C but not always printed
C This routine must be called before all other xplor energy terms
C
      RENR(SSCRIPT) = SCRIPTING_ENERGY()
C      IF ( RENR(SSCRIPT).EQ.0.0D0 ) THEN
C         QENER(SSCRIPT)=.FALSE.
C      ELSE
C         QENER(SSCRIPT)=.TRUE.
C      END IF
      IF (QENER(SSCRIPT) .AND. TIMER.GT.1) THEN
           CALL DSPCPU(' ENERGY: after scripting term(s)')
      END IF
C
C Determine the last double selection that is turned on. 
      DO I=1,NDSELE
      IF (ABS(DSWGHT(I,SSVDW))   .GE.RSMALL.OR.
     &    ABS(DSWGHT(I,SSELEC))  .GE.RSMALL.OR.
     &    ABS(DSWGHT(I,SSGBSELF)).GE.RSMALL.OR.
     &    ABS(DSWGHT(I,SSGBINT)) .GE.RSMALL.OR.
     &    ABS(DSAVWT(I,SSVDW))   .GE.RSMALL.OR.
     &    ABS(DSAVWT(I,SSELEC))  .GE.RSMALL) THEN
      NNDSELE=I
      END IF
      END DO
C
C
C Initialization of Generalized Born
C
      IF (QENER(SSGBSELF).OR.QENER(SSGBINT).OR.
     &    QENER(SSPGBSLF).OR.QENER(SSPGBINT)) THEN
      IF (ACEINI) THEN
C Fill ace parameter arrays (MUPAR, OMPAR, SIGPAR)
      CALL PARACE
C Calculate upper bound for solvation radii
      CALL BSOLVINI
      ACEINI=.FALSE.
      END IF
C
C Initialize ESELN, DEINTB, FREACX, FREACY, FREACZ
      CALL GBZERO
C First GB self-energy pass: Loop over double selections
C Accumulate ESELN
      DO N=1,NDSELE
      IF (ABS(DSWGHT(N,SSGBSELF)).GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSGBINT)) .GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSPGBSLF)).GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSPGBINT)).GE.RSMALL) THEN
      CALL GBSELF(N,HEAP(IINTER(N)),NNDSELE,
     &    REN2(SSGBSELF),REN2(SSPGBSLF),0)
      END IF
      END DO
C compute BSOLV and ESELC from ESELN
      CALL GBUPDA
C
C Second GB self-energy pass: Loop over double selections
C Accumulate self-energy and self forces
C Accumulate DEINTB, FREACX,Y,Z (using ESELC, BSOLV)
C ACE, PACE energy terms are initialized in ACEPASS
      DO N=1,NDSELE
      IF (ABS(DSWGHT(N,SSGBSELF)).GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSGBINT)) .GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSPGBSLF)).GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSPGBINT)).GE.RSMALL) THEN
      CALL GBSELF(N,HEAP(IINTER(N)),NNDSELE,
     &    REN2(SSGBSELF),REN2(SSPGBSLF),1)
      RENR(SSGBSELF)=RENR(SSGBSELF)+REN2(SSGBSELF)
      RENR(SSPGBSLF)=RENR(SSPGBSLF)+REN2(SSPGBSLF)
      END IF
      END DO
C
      END IF
C
C End of Generalized Born initialization      
C
C
      IF (QENER(SSUSER)) THEN
      CALL USERE(RENR(SSUSER),0,0,NATOM)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after USER term ')
      END IF
C
C loop over all active double selections and call routines that are
C sensitive to double-selections.
      DO N=1,NDSELE
      CALL ENERG2(HEAP(IINTER(N)),N)
      DO I=1,NENERT
      RENR(I)=RENR(I)+REN2(I)
      ENDDO
      ENDDO
C
C call energy routines that are insensitive to double-selections
      IF (QENER(SSHARM)) THEN
      CALL ECNSTR(RENR(SSHARM),REFX,REFY,REFZ,KCNSTR,NATOM,KCEXPN,
     &            QPLANAR,PNORMAL)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after harm. CONStr. term ')
      END IF
C
      IF (QENER(SSNOE)) THEN
      CALL ENOE(RENR(SSNOE),'NOAN',0)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after NOE constr. term')
      END IF
C
C three-bond J coupling energy
C
      IF (QENER(SSJCOUP)) THEN
      CALL ECOUP(RENR(SSJCOUP), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after J coupling term')
      END IF
C
C anisotropy energy
      IF(QENER(SSANIS)) THEN
      CALL EANIS(RENR(SSANIS),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Anisotropy term')
      ENDIF
C
C dipolar energy
      IF (QENER(SSXDIP) .or. QENER(SSDIPO)) THEN
      CALL EXDIP(RENR(SSXDIP),'ENERGY ')
      RENR(SSDIPO) = RENR(SSXDIP)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Dipolar term')
      ENDIF
c     ------------------------------------------------------------------
c     Energy terms related to PARArestraints (2003)
c
C
C pseudocontact shifts energy
      IF (QENER(SSXPCS)) THEN
      CALL EXPCS(RENR(SSXPCS),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after PCS term')
      ENDIF
C
C residual dipolar couplings energy
      IF (QENER(SSXRDC)) THEN
      CALL EXRDC(RENR(SSXRDC),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after RDC term')
      ENDIF
C
C cross-correlation rates energy
      IF (QENER(SSXCCR)) THEN
      CALL EXCCR(RENR(SSXCCR),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after CCR term')
      ENDIF
C
C RDCANGLES energy
      IF (QENER(SSXANGLE)) THEN
      CALL EXANGLES(RENR(SSXANGLE),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after ANG term')
      ENDIF
c     ------------------------------------------------------------------
C
C Susceptibility anisotropy energy
      IF(QENER(SSSANI)) THEN
      CALL ESANI(RENR(SSSANI),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Susc-Anisotropy term')
      ENDIF
C
C Diffusion anisotropy energy
      IF(QENER(SSDANI)) THEN
      CALL EDANI(RENR(SSDANI),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Diff-Anisotropy term')
      ENDIF
C
C
C Chemical Shift Anisotropy energy
      IF(QENER(SSDCSA)) THEN
      CALL EDCSA(RENR(SSDCSA),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Chem-Shift-Anis term')
      ENDIF

C
C
C Hbond distance and angle correlation energy
      IF(QENER(SSHBDA)) THEN
      CALL EHBDA(RENR(SSHBDA),'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Hbond-Dist-Angle term')
      ENDIF

C Vector Angle energy
      IF(QENER(SSVEAN)) THEN
         CALL EVEAN(RENR(SSVEAN),'ENERGY ')
         IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Vector-Angle term')
      ENDIF
C
C trio energy term
      IF (QENER(SSTRIO)) THEN
            CALL ETRIO(RENR(SSTRIO), 'ENERGY ')
            IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after trio term')
      END IF
C
C pair energy term
      IF (QENER(SSORIENT)) THEN
            CALL EORIENT(RENR(SSORIENT), 'ENERGY ')
            IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after pair term')
      END IF
C
C collapse rgyr term
      IF (QENER(SSCLPS)) THEN
           CALL ECOLLAPSE(RENR(SSCLPS), 'ENERGY')
           IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after collapse term')
      END IF
C
C carbon chemical shift energy
C
      IF (QENER(SSCARB)) THEN
      CALL ECSHIFT(RENR(SSCARB), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after carbon shift term')
      END IF
C
C proton chemical shift energy
C
      IF (QENER(SSPROT)) THEN
      CALL EPROTONSHIFT(RENR(SSPROT), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after proton shift term')
      END IF
C
C one bond couplings energy
C
      IF (QENER(SSONEJ)) THEN
      CALL EONEBOND(RENR(SSONEJ), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after one bond coup term')
      END IF
C
C gaussian torsion angle database energy
C
      IF (QENER(SSRAMA)) THEN
      CALL ERAMA(RENR(SSRAMA), 'ENERGY ') 
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after torsion DB term')
      END IF
C
C non-gaussian torsion angle database energy
C
      IF (QENER(SSXRAM)) THEN
      CALL EXRAM(RENR(SSXRAM), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after torsion DB term')
      END IF
C
C bond angle database energy
C
      IF (QENER(SSANGDB)) THEN
           CALL EANGLEDB(RENR(SSANGDB), 'ENERGY ')
           IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after angle DB term')
      END IF
C
C paramagnetic relaxation enhancement energy
C
      IF (QENER(SSPMAG)) THEN
           CALL EPMAG(RENR(SSPMAG), 'ENERGY ')
           IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after PMAG term')
      END IF
C
      IF (QENER(SSRELA)) THEN
      CALL ERELAX(RENR(SSRELA),'GRAD')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after relaxation term')
      END IF
C
      IF (QENER(SSDG)) THEN
      CALL EMMDG(RENR(SSDG))
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after DG term')
      END IF
C
      IF (QENER(SSCDIH)) THEN
C
C A.Bonvin Dec 1995
C cross-validation on dihedral angles: use only working set
C
      IF (DIHICV.GT.0) THEN
      CALL ETOR(RENR(SSCDIH),EDUMMY,HEAP(IWCIP),HEAP(IWCJP),HEAP(IWCKP),
     &          HEAP(IWCLP),HEAP(IWCICP),CWNPHI,HEAP(IWCCPC),
     &          HEAP(IWCCPD),HEAP(IWCCPB),'GENERAL',
     &          HEAP(IWCCPO),HEAP(IWCCPE),'NOAN',CNSCA,ONE)
      ELSE
      CALL ETOR(RENR(SSCDIH),EDUMMY,HEAP(ICIP),HEAP(ICJP),HEAP(ICKP),
     &          HEAP(ICLP),HEAP(ICICP),CNPHI,HEAP(ICCPC),
     &          HEAP(ICCPD),HEAP(ICCPB),'GENERAL',
     &          HEAP(ICCPO),HEAP(ICCPE),'NOAN',CNSCA,ONE)
      ENDIF
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Cons-DIHEdral term ')
      END IF
C
      IF (QENER(SSSBOU)) THEN
      CALL BNDRY(RENR(SSSBOU))
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after SBOUnd term ')
      END IF
C
      IF (QENER(SSXREF)) THEN
      CALL XRENER(RENR(SSXREF))
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after XREFIne term')
      END IF
C
      IF (QENER(SSNCS)) THEN
      CALL ENENCS(RENR(SSNCS))
      IF (TIMER.GT.1) THEN
      CALL DSPCPU(' ENERGY: after non-crystallog. restraint term')
      END IF
      END IF
C
      IF (QENER(SSPLN)) THEN
      CALL ENEPLN(RENR(SSPLN))
      IF (TIMER.GT.1) THEN
      CALL DSPCPU(' ENERGY: after planarity restraint term')
      END IF
      END IF
C
      RETURN
      END
C
      SUBROUTINE ENEINI
C
C Routine initializes energy terms
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C I/O
      INCLUDE  'psf.fcm'
      INCLUDE  'cnst.fcm'
      INCLUDE  'ener.fcm'
      INCLUDE  'symbol.fcm'
C local
      INTEGER I
C begin
C energy term flags and descriptors
      DO I=1,NENERT
      RENR(I)=0.0D0
      ANER(I)='    '
      QENER(I)=.FALSE.
      END DO
C
C accumulation slots, only to inquire, not to manipulate
      ANER(SSTOTE)='TOTE'
      ANER(SSTOTK)='TOTK'
      ANER(SSENER)='ENER'
      ANER(SSTEMP)='TEMP'
      ANER(SSSD)='GRAD'
      ANER(SSPERT)='PERT'
C
C regular slots
      ANER(SSBOND)='BOND'
      QENER(SSBOND)=.TRUE.
      ANER(SSANGL)='ANGL'
      QENER(SSANGL)=.TRUE.
      ANER(SSDIHE)='DIHE'
      QENER(SSDIHE)=.TRUE.
      ANER(SSIMPR)='IMPR'
      QENER(SSIMPR)=.TRUE.
      ANER(SSVDW)='VDW '
      QENER(SSVDW)=.TRUE.
      ANER(SSELEC)='ELEC'
      QENER(SSELEC)=.TRUE.
      ANER(SSGBSELF)='GBSE'
      ANER(SSGBINT)= 'GBIN'
      ANER(SSHBON)='HBON'
      ANER(SSHARM)='HARM'
      ANER(SSCDIH)='CDIH'
      ANER(SSUSER)='USER'
      ANER(SSNOE)='NOE '
      ANER(SSRELA)='RELA'
      ANER(SSDG)='DG  '
      ANER(SSJCOUP)='COUP'
      ANER(SSANIS)='ANIS'
      ANER(SSSANI)='SANI'
      ANER(SSDANI)='DANI'
      ANER(SSXDIP)='XDIP'
      ANER(SSDIPO)='DIPO'
c     ------------------------------------------------------------------
c     Slots for PARArestraints (2003)
c
      ANER(SSXPCS)='XPCS'
      ANER(SSXRDC)='XRDC'
      ANER(SSXCCR)='XCCR'
      ANER(SSXANGLE)='XANG'
c     ------------------------------------------------------------------
      ANER(SSDCSA)='DCSA'
      ANER(SSHBDA)='HBDA'
      ANER(SSVEAN)='VEAN'
      ANER(SSCARB)='CARB'
      ANER(SSPROT)='PROT'
      ANER(SSONEJ)='ONEB'
      ANER(SSRAMA)='RAMA'
      ANER(SSXRAM)='XRAM'
      ANER(SSXREF)='XREF'
      ANER(SSPVDW)='PVDW'
      ANER(SSPELE)='PELE'
      ANER(SSPGBSLF)= 'PGBS'
      ANER(SSPGBINT)= 'PGBI'
      ANER(SSSBOU)='SBOU'
      ANER(SSNCS)='NCS '
      ANER(SSPLN)='PLAN'
      ANER(SSANGDB)='ANDB'
      ANER(SSTRIO)='TRIO'
      ANER(SSORIENT)='ORIE'
      ANER(SSCLPS)='COLL'
      ANER(SSCRIPT)='SCRI'
      ANER(SSPMAG)='PMAG'
      QENER(SSCRIPT)=.FALSE.
C
C harmonic restraints
      PNORMAL(1)=0.0D0
      PNORMAL(2)=0.0D0
      PNORMAL(3)=0.0D0
      QPLANAR=.FALSE.
C
      EOLD=0.0D0
      RETURN
      END
C
      SUBROUTINE EFLAGS(MODE)
C
C Routine sets flags which energy routines are to be used.
C
C For syntax see main parsing loop "HELP"
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE  'psf.fcm'
      INCLUDE 'cnst.fcm'
      INCLUDE  'ener.fcm'
      INCLUDE  'comand.fcm'
      INCLUDE  'funct.fcm'
      INCLUDE  'nbonds.fcm'
      CHARACTER*(*) MODE
C local
      INTEGER J, NINCL
      LOGICAL TERM, FOUND, MATCH
      CHARACTER*4 BNER(NENERT)
C begin
      TERM=.FALSE.
      CALL PUSEND('FLAGS>')
374   CONTINUE
      CALL NEXTWD('FLAGS>')
      CALL MISCOM('FLAGS>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &' <flag-statement> :==FLAG {<flag-option>} END',
     &'    <flag-option>:==',
     &'    ?',                  
     &'    <control-statement>',
     &'    INCLude  { <energy-term>* } ',
     &'    EXCLude  { <energy-term>* } ',
     &'       <energy-term>:== BOND|ANGL|DIHE|IMPR|VDW|ELEC|GBSE|GBIN|',
     &'       HBON|XREF|NOE|PVDW|PELE|HARM|CDIH|USER|SBOU|NCS|PLAN|',
     &'       PGBS|PGBI|COUP|CARB|PROT|ONEJ|RAMA|XRAM|ANDB|ANIS|TRIO',
     &'       ORIE|SANI|DANI|DIPO|DCSA|HBDA|VEAN|SCRIpt',
c     ------------------------------------------------------------------
c     Energy terms related to PARArestraints (2003)
c
     &'       XPCS|XRDC|XCCR|XANG',
c     ------------------------------------------------------------------
     &' remark: wildcards are allowed for <energy-term>'
C-DOCUMENTATION-SOURCE-END
C
      ELSE IF (WD(1:4).EQ.'?   ') THEN
      WRITE(6,'(A)') ' EFLAGS: the following energy flags are set'
      NINCL=0
      DO J=1,NENERT
      IF (ANER(J).NE.'    '.AND.QENER(J)) THEN
      NINCL=NINCL+1
      BNER(NINCL)=ANER(J)
      END IF
      END DO
      WRITE(6,'(1X,A,14(A,A))') 'EFLAGS:',(' ',BNER(J),J=1,NINCL)
      ELSE IF (WD(1:4).EQ.'INCL') THEN
      TERM=.TRUE.
      ELSE IF (WD(1:4).EQ.'EXCL') THEN
      TERM=.FALSE.
      ELSE
      FOUND=.FALSE.
      DO J=1,NENERT         
      CALL EQSTWC(ANER(J),4,WD(1:4),4,1,1,MATCH)
      IF (MATCH) THEN
      QENER(J)=TERM
      FOUND=.TRUE.
      END IF
      END DO
      IF (.NOT.FOUND) CALL CHKEND('FLAGS>',DONE)
      END IF
C
C don't include the accumulation variables
C TOTE, TOTK, TEMP, ENER
      QENER(SSTOTE)=.FALSE.
      QENER(SSTOTK)=.FALSE.
      QENER(SSTEMP)=.FALSE.
      QENER(SSENER)=.FALSE.
      QENER(SSSD)=.FALSE.
      QENER(SSPERT)=.FALSE.
      IF (QENER(SSGBSELF).OR.QENER(SSPGBSLF).OR.
     &    QENER(SSGBINT) .OR.QENER(SSPGBINT)) THEN
      ACEINI=.TRUE.
      END IF
C
      END IF
      IF (.NOT. (DONE)) goto 374
      DONE=.FALSE.
C
      RETURN
      END
C
      SUBROUTINE PGETE(ICYCLE)
C
C Command interpreter for stand-alone and accumulation
C requests for energy
C
C Author: Axel T. Brunger
C =======================
      IMPLICIT NONE
C I/O
      INCLUDE  'psf.fcm'
      INCLUDE  'cnst.fcm'
      INCLUDE  'coord.fcm'
      INCLUDE  'funct.fcm'
      INCLUDE  'comand.fcm'
      INCLUDE  'ener.fcm'
      INCLUDE  'consta.fcm'
      INCLUDE  'heap.fcm'
      INTEGER ICYCLE
C local
      INTEGER I
      LOGICAL QPRINT
      CHARACTER*4 SACCU
C
C defaults
      QPRINT=.TRUE.
      SACCU='ENER'
C
C parsing
      CALL PUSEND('ENERGY>')
467   CONTINUE
      CALL NEXTWD('ENERGY>')
      CALL MISCOM('ENERGY>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &'<energy-statement>:==ENERgy { [<control-statement>] ',
     &' [ACCUmulate=PRINt|ENERgy|RESEt] } END',
     &' Remarks: if no ACCUmulate is specified or ACCUmulate=',
     &' ENERgy is specified, the energies will be computed,',
     &' printed and accumulated. If ACCUmulate=RESEt the energy',
     &' accumulation variables are reset without performing an',
     &' energy calculation. If ACCUmulate=PRINt accumulation',
     &' information is printed without performing an energy',
     &' calculation. The result of the calculation is also',
     &' stored in the symbols $ENER, $VDW, $ELEC, etc.'
C-DOCUMENTATION-SOURCE-END
C
C turn off automatic call to ENERGY in this case
      SACCU='    '
C
      ELSE IF (WD(1:4).EQ.'ACCU') THEN
      CALL NEXTA4('ACCUmulate=',SACCU)
      ELSE
      CALL CHKEND('ENERGY>',DONE)
      END IF             
      END IF
      IF (.NOT. (DONE)) goto 467
      DONE=.FALSE.
C
      IF (SACCU.EQ.'ENER') THEN
      CALL ENERGY
      ICYCLE=ICYCLE+1
      IF (QPRINT) THEN
      WRITE(6,'(A,I6,A)')
     & ' --------------- cycle=',ICYCLE,
     & ' --------------------------------------------------'
      CALL PRINTE(RENR)
      WRITE(6,'(2A)') ' --------------------------------------------',
     & '-----------------------------------'
      END IF
C
C accumulation stuff
      IF (ICYCLE.EQ.1) THEN
      DO I=1,NENERT
      RENRA(I)=0.0D0
      RENR2A(I)=0.0D0
      END DO
      END IF
      DO I=1,NENERT
      RENRA(I)=RENRA(I)+RENR(I)
      RENR2A(I)=RENR2A(I)+RENR(I)*RENR(I)
      END DO
C
      ELSE IF (SACCU.EQ.'RESE') THEN
      ICYCLE=0
      DO I=1,NENERT
      RENRA(I)=0.0D0
      RENR2A(I)=0.0D0
      END DO
C
      ELSE IF (SACCU.EQ.'PRIN') THEN
      DO I=1,NENERT
      RENRP(I)=RENR(I)
      RENR(I)=RENRA(I)/ICYCLE
      END DO
      WRITE(6,'(A,I8,A)') ' --------------- averages for last ',
     & ICYCLE,'  steps -----------------------------'
      CALL PRINTE(RENR)
      WRITE(6,'(2A)') ' --------------------------------------------',
     &                 '-----------------------------------'
      DO I=1,NENERT
      RENR(I)=RENR2A(I)/ICYCLE-RENR(I)*RENR(I)
      IF (RENR(I).LE.RSMALL) THEN
      RENR(I)=0.0D0
      ELSE
      RENR(I)=SQRT(RENR(I))
      END IF
      END DO
      WRITE(6,'(A,I8,A)') ' --------------- rms fluctations for last ',
     & ICYCLE,' steps -----------------------'
      CALL PRINTE(RENR)
      WRITE(6,'(2A)') ' --------------------------------------------',
     &                 '-----------------------------------'
      DO I=1,NENERT
      RENR(I)=RENRP(I)
      END DO
      END IF
C
      RETURN
      END
C
      SUBROUTINE PRINTE(RENRL)
C
C See routine PRINT2 below
C
C Author: Axel T. Brunger
C =======================
C
C I/O
      DOUBLE PRECISION RENRL(*)
C begin
      CALL PRINT2(.TRUE.,RENRL)
      RETURN
      END
C
      SUBROUTINE PRINT2(QSPCL,RENRL)
C
C Routine prints energies, if QSPCL is true, then this includes the
C Etotal, the grad(E), and the perturbation term.  
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C I/O
      LOGICAL QSPCL
      DOUBLE PRECISION RENRL(*)
      INCLUDE  'psf.fcm'
      INCLUDE 'cnst.fcm'
      INCLUDE  'ener.fcm'
      INCLUDE  'deriv.fcm'
C local
      CHARACTER*80 LINE
      CHARACTER*20 ST
      INTEGER NTERMS, J, START, STOP, STLEN
C parameters
      DOUBLE PRECISION MAXNUM
      DOUBLE PRECISION MINNUM
      PARAMETER (MAXNUM=999999.D0)
      PARAMETER (MINNUM=-99999.D0)
C begin
C
C write total energy
      LINE=' '
      LINE(2:2)='|'
      LINE(80:80)='|'
      IF (QSPCL) THEN
      IF (RENRL(SSENER).GT.MAXNUM.OR.RENRL(SSENER).LT.MINNUM) THEN
      WRITE(ST,'(E10.2)') RENRL(SSENER)
      ELSE
      WRITE(ST,'(F10.3)') RENRL(SSENER)
      END IF
      STLEN=10
      CALL TRIML(ST,STLEN)
      WRITE(LINE(3:21),'(4A)') ' Etotal =',ST(1:STLEN)
C
C write the RMS gradient
      IF (RENRL(SSSD).GT.MAXNUM.OR.RENRL(SSSD).LT.MINNUM) THEN
      WRITE(ST,'(E10.2)') RENRL(SSSD)
      ELSE
      WRITE(ST,'(F10.3)') RENRL(SSSD)
      END IF
      STLEN=10
      CALL TRIML(ST,STLEN)
      WRITE(LINE(22:40),'(4A)') ' grad(E)=',ST(1:STLEN)
C
      NTERMS=2
      ELSE
      NTERMS=0
      END IF
C
C now write the partial energy terms
      DO J=1,NENERT
      IF (QENER(J).AND.ANER(J).NE.'    ') THEN
      IF (NTERMS.GE.4) THEN
      WRITE(6,'(A80)') LINE
      LINE=' '
      LINE(2:2)='|'
      LINE(80:80)='|'
      NTERMS=0
      END IF
      NTERMS=NTERMS+1
      IF (RENRL(J).GT.MAXNUM.OR.RENRL(J).LT.MINNUM) THEN
      WRITE(ST,'(E10.2)') RENRL(J)
      ELSE
      WRITE(ST,'(F10.3)') RENRL(J)
      END IF
      STLEN=10
      CALL TRIML(ST,STLEN)
      START=(NTERMS-1)*19 +3
      STOP=NTERMS*19+2
      WRITE(LINE(START:STOP),'(4A)') ' E(',ANER(J),')=',ST(1:STLEN)
      END IF
      END DO
      IF (NTERMS.GE.1) WRITE(6,'(A80)') LINE
C write perturbation
      IF (QPERT.AND.QSPCL) THEN
      LINE=' '
      LINE(2:2)='|'
      LINE(80:80)='|'
      IF (RENRL(SSPERT).GT.MAXNUM.OR.RENRL(SSPERT).LT.MINNUM) THEN
      WRITE(ST,'(E10.2)') RENRL(SSPERT)
      ELSE
      WRITE(ST,'(F10.3)') RENRL(SSPERT)
      END IF
      STLEN=10
      CALL TRIML(ST,STLEN)
      WRITE(LINE(3:20),'(4A)') ' Vpert =',ST(1:STLEN)
      WRITE(6,'(A80)') LINE
      ENDIF
C
      RETURN
      END
C=====================================================================
      SUBROUTINE ENERG2(INTERE,N)
C
C Front-end routine for various partial energy routines
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE  'psf.fcm'
      INCLUDE  'deriv.fcm'
      INCLUDE  'cnst.fcm'
      INCLUDE  'consta.fcm'
      INCLUDE  'ener.fcm'
      INCLUDE  'param.fcm'
      INCLUDE  'ace.fcm'
      INCLUDE  'timer.fcm'
      INCLUDE  'funct.fcm'
      INCLUDE  'heap.fcm'
      INTEGER N, INTERE(*)
C local
      INTEGER I, NNDSELE
      DOUBLE PRECISION TOTAL
      LOGICAL ERR
C parameters
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
C
C initialization 
      DO I=1,NENERT
        REN2(I)=ZERO
        RENV(I)=ZERO
      ENDDO
C
C check that all atomic coordinates are known
      CALL ATMCHK(HEAP(IINTER(N)),ERR)
      IF (.NOT.ERR) THEN
C
      IF (NBOND.GT.0.AND.QENER(SSBOND).AND. 
     &    (ABS(DSWGHT(N,SSBOND)).GE.RSMALL.OR.
     &     ABS(DSAVWT(N,SSBOND)).GE.RSMALL)) THEN
      CALL EBOND(REN2(SSBOND),RENV(SSBOND),IB,JB,INTERE,NBOND,
     &  ACBC,ACBB,QACBC,QACBB,'NOAN',
     &  DSWGHT(N,SSBOND),DSAVWT(N,SSBOND),IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after BOND term ')
      END IF
C
      IF (NTHETA.GT.0.AND.QENER(SSANGL).AND.
     &    (ABS(DSWGHT(N,SSANGL)).GE.RSMALL.OR.
     &     ABS(DSAVWT(N,SSANGL)).GE.RSMALL)) THEN
      CALL EANGLE(REN2(SSANGL),RENV(SSANGL),IT,JT,KT,INTERE,
     &    NTHETA,ACTC,ACTB,ACTUC,ACTUB,QACTC,QACTB,QACTUC,QACTUB,
     &    'NOAN',DSWGHT(N,SSANGL),DSAVWT(N,SSANGL),IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after ANGLE term ')
      END IF
C
      IF (NPHI.GT.0.AND.QENER(SSDIHE).AND.
     &    (ABS(DSWGHT(N,SSDIHE)).GE.RSMALL.OR.
     &     ABS(DSAVWT(N,SSDIHE)).GE.RSMALL)) THEN
      CALL EDIHE(REN2(SSDIHE),RENV(SSDIHE),IP,JP,KP,LP,INTERE,
     &      NPHI,ACPC,ACPD,ACPB,
     &      QACPC,QACPD,QACPB,'NORMAL',0.0D0,0,'NOAN',
     &      DSWGHT(N,SSDIHE),DSAVWT(N,SSDIHE),IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after DIHEdral term ')
      END IF
C
      IF (NIMPHI.GT.0.AND.QENER(SSIMPR).AND.
     &    (ABS(DSWGHT(N,SSIMPR)).GE.RSMALL.OR.
     &     ABS(DSAVWT(N,SSIMPR)).GE.RSMALL)) THEN
      CALL EIMPR(REN2(SSIMPR),RENV(SSIMPR),IM,JM,KM,LM,INTERE,
     &    NIMPHI,ACIC,ACID,ACIB,
     &    QACIC,QACID,QACIB,'NORMAL',0.0D0,0,'NOAN',
     &    DSWGHT(N,SSIMPR),DSAVWT(N,SSIMPR),IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after IMPRoper term ')
      END IF
C
      IF (QENER(SSELEC).OR.QENER(SSVDW)  .OR.
     &    QENER(SSPELE).OR.QENER(SSPVDW)) THEN
C
C determine the last double selection that is turned on.
      NNDSELE=0
      DO I=1,NDSELE
      IF (ABS(DSWGHT(I,SSVDW)) .GE.RSMALL.OR.
     &    ABS(DSWGHT(I,SSELEC)).GE.RSMALL.OR.
     &    ABS(DSAVWT(I,SSVDW)) .GE.RSMALL.OR.
     &    ABS(DSAVWT(I,SSELEC)).GE.RSMALL) THEN
      NNDSELE=I
      END IF
      END DO
C
      IF (ABS(DSWGHT(N,SSVDW)) .GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSELEC)).GE.RSMALL.OR.
     &    ABS(DSAVWT(N,SSVDW)) .GE.RSMALL.OR.
     &    ABS(DSAVWT(N,SSELEC)).GE.RSMALL) THEN
      CALL ENBOND(REN2(SSVDW),REN2(SSELEC),REN2(SSPVDW),REN2(SSPELE),
     &            RENV(SSVDW),RENV(SSELEC),RENV(SSPVDW),RENV(SSPELE),N,
     &            NNDSELE,'NOAN')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after NONBonded term ')
      END IF
      END IF
C
      IF (QENER(SSGBINT).OR.QENER(SSPGBINT)) THEN
      IF (ABS(DSWGHT(N,SSGBINT)).GE.RSMALL.OR.
     &    ABS(DSWGHT(N,SSPGBINT)).GE.RSMALL) THEN
      CALL ENGB(REN2(SSGBINT),REN2(SSPGBINT),N,INTERE,NNDSELE)
      END IF
      END IF
C
      IF (QENER(SSHBON).AND.
     &    (ABS(DSWGHT(N,SSHBON)).GE.RSMALL.OR.
     &     ABS(DSAVWT(N,SSHBON)).GE.RSMALL)) THEN
      CALL EHBOND(REN2(SSHBON),RENV(SSHBON),N)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after HBONd term ')
      END IF
C
      IF (QPERT) THEN
      TOTAL=ZERO
      DO I=1,NENERT
      TOTAL=TOTAL+RENV(I)
      ENDDO
      REN2(SSPERT)=TOTAL
      END IF
C
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE ATMCHK(INTERE,ERR)
C
C subroutine checks whether all atoms are known that are
C referenced in the interaction energy array.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE  'funct.fcm'
      INCLUDE  'psf.fcm'
      INCLUDE  'coord.fcm'
      INTEGER INTERE(*)
      LOGICAL ERR
C local
      INTEGER I
C begin
      ERR=.FALSE.
      DO I=1,NATOM
      IF (.NOT.INITIA(I,X,Y,Z).AND.INTERE(I).LT.MAXA) THEN
      ERR=.TRUE.
      WRITE(6,'(9A)')
     &  ' %ATMCHK-ERR: unknown coordinates for atom "', 
     &    SEGID(I),'-',RESID(I),'-',RES(I),'-',TYPE(I),'"'
      END IF
      END DO
      IF (ERR) THEN
      CALL WRNDIE(-5,'ATMCHK','Unknown coordinates')
      END IF
      RETURN
      END
