C*$* NO CONCURRENTIZE
      SUBROUTINE XPLOR_INIT
      IMPLICIT NONE
C
C common (global) variables and constants
      INCLUDE  'comand.fcm'
      INCLUDE  'intcr.fcm'
      INCLUDE  'seed.fcm'
      INCLUDE  'vector.fcm'
      INCLUDE  'timer.fcm'
      INCLUDE  'update.fcm'
      INCLUDE  'psf.fcm'
      INCLUDE  'cnst.fcm'
      INCLUDE  'coord.fcm'
      INCLUDE  'deriv.fcm'
      INCLUDE  'ener.fcm'
      INCLUDE  'consta.fcm'
C
C file-scope variables
      INTEGER ICYCLE
      COMMON /XPLOR_F/ ICYCLE
      SAVE   /XPLOR_F/
C =====
C local
C =====
      INTEGER I, L
      DOUBLE PRECISION DUMMY
      DOUBLE COMPLEX CDUMMY
      CHARACTER*12 USERNM
      CHARACTER*14 SYSNM
      CHARACTER*9  DATE
      CHARACTER*8  TIME
C
C =====
C begin
C =====
C     
C initialize the file handling facility
      CALL VOPEN(0,'$$INITIAL$$',' ',' ',ERROR)
C
C CHARACTER*4 array CSTACK initialization
      CALL CINIST(.FALSE.)
      
C
C HEAP initialization
      CALL INITHP
C
C initialize command parsing
      CALL INIPRS
      CALL DECLAR( 'XPLOR_VERSION', 'ST', '3.851', DUMMY, CDUMMY )
C
C
C initialize the double selection set up
      CALL DSRSET('INIT')
C
C initialize the nonbonded list
      CALL NBDSET('INIT')
C
C initialize the fast nonbonded setup
      CALL FNBSET('INIT')
C
C initialize hydrogen bonding parameters
      CALL HBDSET('INIT')
C
C initialize the trajectory writing facility
      CALL TRTINI
C
C initialize the parameter learning facility
      CALL PRTINI
C
C torsion angle dynamics
      CALL TORINI
C
C initialize the distance geometry bounds matrix stores
      CALL DGINIT
C
C initialize ARIA
      CALL ARIINI
C
C initialize j coupling refinement
      CALL COUPINIT
C
C initialize Anisotropy refinement
C
      CALL ANISINIT
C
C initialize Susceptibility Anisotropy refinement
C
      CALL SANIINIT
C
C initialize Dipolar coupling refinement
C
      CALL XDIPINIT
c     ------------------------------------------------------------------
c     PARArestraints (2003)
c
C
C initialize Pseudocontact shifts refinement
C
      CALL XPCSINIT
C
C initialize Residual dipolar couplings refinement
C
      CALL XRDCINIT
C
C initialize Cross-correlation rates refinement
C
      CALL XCCRINIT
C
C initialize RDC-ANGLES refinement
C
      CALL XANGLESINIT
c     ------------------------------------------------------------------
C
C initialize Diffusion Anisotropy refinement
C
      CALL DANIINIT
C
C initialize Chemical Shift Anisotropy refinement
C
      CALL DCSAINIT
C
C initialize Hbonds Distance and Angle Correlation refinement
C
      CALL HBDAINIT
C
C initialize Vector Angle  refinement
C
      CALL VEANINIT
C
C initialize carbon chemical shift stuff
      CALL CSHIFTINIT
C
C initialize the proton chemical shift stuff
      CALL HSHIFTINIT
C
C initialize the 1-bond J coupling stuff
      CALL ONEINIT
C
C initialize the Gaussian Ramachandran stuff
      CALL RAMAINIT
C
C initialize the Non-gaussian Ramachandran stuff
      CALL XRAMINIT
C
C initialize the angle database stuff
C
      CALL ANGLEDBINIT
C
      CALL COLLAPSEINIT
C
      CALL PMAGINIT
C
C
C
C initialize the relaxation matrix routines
      CALL RELINI
C
C initialize trio stuff
      CALL TRIOINIT
C initialize pair stuff
      CALL ORIENTINIT
C
C set bond, angle, dihedral, improper type-based parameter update flags
      UPBOND=.TRUE.
      UPANGL=.TRUE.
      UPDIHE=.TRUE.
      UPIMPR=.TRUE.
C
C initialize scalar stores
      DO I=1,MAXSTO
      PTRSTO(I)=0
      LENSTO(I)=0
      END DO
C
C constraints
      CALL CSTRES
C
C solvent boudaries
      CALL SBINI
C
C dihedral angle restraints
      CALL CDIINI
C
C NOE tables
      CALL NOEINI
C
C crystallographic restraints
      CALL XRERES
C
C energy term flags and descriptors
      CALL ENEINI
C
C non-crystallographic symmetry operators and counters
      CALL NCSINR
      CALL NCSINS
C
C planarity restraints
      CALL PLNINR
C
C SHAKE
      CALL SHKINI
C
C RTF
      CALL RTFINI
C
C PSF
      CALL PSFRES
C
C parameters
      CALL PARINI
C
C IC
      LENIC=0
C
C warning level and bomb level
      if ( WRNLEV.LT.0 ) THEN
         WRNLEV=5
      END IF
      BOMLEV=0
C
C random number generator seed
      SEED=314159.0D0
C
C display and print files are set to system output (default)
      DUNIT=6
      PUNIT=6
C
C journal file unit is set to -1 (switched off)
      PRUNIT=-1
C
C initialize timer
      CALL VINTIM
      TIMER=0
C
C set counter for some ENERGY calls
      ICYCLE=0
C
C initialize scripting interpreters
      CALL PYTHON_INIT(natom,x,y,z,xv,yv,zv,dx,dy,dz,
     &     segid, res, resid, type, iac,
     &     nenert,qener,aner,renr,
     &     nbond,ib,jb,amass,fbeta,cg,wd,imove,timfac,kboltz,
     &     seed,wrnlev,qecho)	

      CALL TCL_INIT(natom,x,y,z,xv,yv,zv,dx,dy,dz,
     &     segid, res, resid, type, iac,
     &     nenert,qener,aner,renr,
     &     nbond,ib,jb,amass,fbeta,cg,wd,imove,timfac,kboltz,
     &     seed,wrnlev,qecho)	

C
C write header
      CALL VDATE(DATE,9,L)
      CALL VTIME(TIME,8,L)
      CALL GETNAM(USERNM,12,L)
      CALL GETSYS(SYSNM,14,L)
      if (wrnlev.gt.0) then
C-BEGIN-NIHXPLOR-HEADER
         WRITE(6,'(A)') '		       XPLOR-NIH version 1.0.6 '
         WRITE(6,'(A)') ' '
         WRITE(6,'(A)') ' G.M. Clore, J. Kuszewski, '
         WRITE(6,'(A,$)') ' C.D. Schwieters, N. Tjandra        based on X-'
         WRITE(6,'(A)') 'PLOR 3.851 by Axel T. Brunger '
         WRITE(6,'(A,$)') ' http://nmr.cit.nih.gov/xplor-nih   Copyrights '
         WRITE(6,'(A)') 'held by Yale and Harvard '
C-END-NIHXPLOR-HEADER
         WRITE(6,'(/,A)') 
     &        ' User: '//USERNM//' on: '//SYSNM//'  at: '//DATE//' '//TIME       
C-PRECOMP-PLACE-DATE-STAMP-HERE
      end if
      RETURN
      END
C
C======================================================================
      SUBROUTINE XPLOR_PARSE(QSUBSHELL)
      IMPLICIT NONE
C input/output
      LOGICAL QSUBSHELL
C command parsing
C
C common (global) variables and constants
      INCLUDE  'comand.fcm'
C
C file-scope variables
      INTEGER ICYCLE
      COMMON /XPLOR_F/ ICYCLE
      SAVE   /XPLOR_F/
C =====
C local
C =====
      INTEGER*4   FD
      INTEGER mapUnitToFD
C ...directories
      CHARACTER*255 NEWDIR,CURDIR
      INTEGER*2 DIRLEN
      CHARACTER*1024 CMD

      CALL PUSEND('X-PLOR>')
      DONE=.FALSE.
300   CONTINUE
      CALL NEXTWD('X-PLOR>')
      CALL MISCOM('X-PLOR>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
C DOCUMENTATION-SOURCE-BEGIN
C
      WRITE(DUNIT,'(10X,A)')
     &'<command> :==',
     &' <auxilary-command>  {* see HELP-<auxilary-command> *}',
     &' ANGLedatabase <angle-database-statement> END ',
     &' CARBon <carbon-shift-statement> END {*carbon shift settings*}',
     &' CONFormation <conformational-database-refinement-statement> ',
     &' {*conformational database refinement *}',
     &' COLLapse <collapse-rgyr-statement> END ',
     &' CONStraints <constraints-statement> END ',
     &' COORmanipulation <coor-statment> END ',
     &' COUPlings <couplings-statement> END ',
     &' ANISotropy <anisotropy-statement> END ',
     &' DELEte <delete-statement> END {* delete atoms *} ',
     &' DISTance <distance-statement> END {* nonbonded analysis *} ',
     &' DYNAmics <dynamics-statement> END {* molecular dynamics *} ',
     &' DUPLicate <duplicate-statement> END {* duplicate structure *}',
     &' ENERgy <energy-statement> END ',
     &' FASTnb <fastnb-statement> END ',
     &' FLAGs <flags-statement> END ',
     &' HBUIld <hbuild-statement> END {* build hydrogen positions*}',
     &' NCS <NCS-statement> END {*non-crystallographic symmetry*} ',
     &' MMDG <mmdg-statement> END {* distance geometry *}',
     &' MINImize <minimize-statement> END {* minimization *} ',
     &' NOE <noe-statement) END {* distance restraints *} ',
     &' ONEBond <one-bond-couplings statement> END {*1J restraints*}',
     &' PARAmeter <parameter-statement> END {*read/append param.*} ',
     &' PMAGnetic <parameter-statement> END {* paramagn. resonance refinement *} ',
     &' PATCh <patch-statement> END {* patch structure *} ',
     &' PICK <pick-statement> {* pick geometric properties *} ',
     &' PRINt=<print-object> '
      WRITE(DUNIT,'(10X,A)')
     &' PROTon <proton-shift-statement> {* proton chemical shift ',
     &'    refinement *}',
     &' READ <read-object> END ',
     &' RELAxation <relaxation statement> END {* NOE backcalc. *}',
     &' RESTraints <restraints-statement> END ',
     &' ROTMan <rotman-statement> END ',
     &' SANIsotropy <Susceptibility Anisotropy-statement> END ',
     &' DANIsotropy <Diffusion Anisotropy-statement> END ',
     &' DIPOlar <Dipolar-coupling-statement> END ',
c     ------------------------------------------------------------------
c     Commands related to PARArestraints (2003)
c
     &' XPCShift <Pseudocontact-shift-statement> END ',
     &' XRDCouplings <Residual-dipolar-coupling-statement> END ',
     &' XCCRates <Cross-correlation-rates-statement> END ',
     &' XANGles <RDC-angles-statement> END ',
     &' XT1Distances <T1-distances-statement> END ',
c     ------------------------------------------------------------------
     &' DCSAnisotropy <Chemical-Shift-Anisotropy-statement> END ',
     &' HBDA <Hbonds distance-angle correlation-statement> END ',
     &' VEAN <vector-angle-statement> END ',
     &' SBOUnd <solvent-boundary-statement> END ',
     &' SEGMent <segment-statment> END  {* generate structure *} ',
     &' SHAKe <shake-statement> END {* apply SHAKE constraints *} ',
     &' STRUcture <structure-statement> END  {* read structure *}',
     &' SURFace <surface-statement> END {* accessible surface *} ',
     &' TEST <test-statements> END ',
     &' TOPOlogy <topology-statement> END {* read topology *} ',
     &' USER <user-statement> END ',
     &' VECTor <vector-statement> {* pick/set atom attributes *} ',
     &' VOLUme <volume-statement> END {* accessible volume *} ',
     &' WRITe <write-object> END',
     &' XREFin <xrefin-statement> END',
     &' TCL { <TCL expressions> } returnToXplor', 'drop into TCL shell',
     &' CTCL "<TCL commands>"', 'eval a single line of TCL commands ',
     &     'enclosed in quotes',
     &' ? {* give current information about structure and files *} '
C-DOCUMENTATION-SOURCE-END
C
C
C
      ELSE IF (WD(1:4).EQ.'ANGL' ) THEN
      CALL READANGLEDB
      ELSE IF (WD(1:4).EQ.'CARB' ) THEN
      CALL READCSHIFT
      ELSE IF (WD(1:4).EQ.'CONS' ) THEN
      CALL CSTRAN
      ELSE IF (WD(1:4).EQ.'REST' ) THEN
      CALL RSTRAN
      ELSE IF (WD(1:4).EQ.'COOR' ) THEN
      CALL CORMAN
      ELSE IF (WD(1:4).EQ.'COUP' ) THEN
      CALL READCOUP
      ELSE IF (WD(1:4).EQ.'ANIS' ) THEN
      CALL READANIS
      ELSE IF (WD(1:4).EQ.'SANI' ) THEN
      CALL READSANI
      ELSE IF (WD(1:4).EQ.'DIPO' .or. WD(1:4).EQ.'XDIP' ) THEN
      CALL READXDIP
c     ------------------------------------------------------------------
c     Commands for PARArestraints (2003)
c
      ELSE IF (WD(1:4).EQ.'XPCS' ) THEN
      CALL READXPCS
      ELSE IF (WD(1:4).EQ.'XRDC' ) THEN
      CALL READXRDC
      ELSE IF (WD(1:4).EQ.'XCCR' ) THEN
      CALL READXCCR
      ELSE IF (WD(1:4).EQ.'XANG' ) THEN
      CALL READXANGLES
      ELSE IF (WD(1:4).EQ.'XT1D' ) THEN
      CALL XT1DIST
c     ------------------------------------------------------------------
      ELSE IF (WD(1:4).EQ.'DCSA' ) THEN
      CALL READDCSA
      ELSE IF (WD(1:4).EQ.'HBDA' ) THEN
      CALL READHBDA
      ELSE IF (WD(1:4).EQ.'DANI' ) THEN
      CALL READDANI
      ELSE IF (WD(1:4).EQ.'VEAN' ) THEN
      CALL READVEAN
      ELSE IF (WD(1:4).EQ.'ARIA' ) THEN
      CALL ARISET
      ELSE IF (WD(1:4).EQ.'DELE' ) THEN
      CALL DELTIC
      ELSE IF (WD(1:4).EQ.'DIST' ) THEN
      CALL DISTAN
      ELSE IF (WD(1:4).EQ.'DUPL' ) THEN
      CALL DUPLIC
      ELSE IF (WD(1:4).EQ.'DYNA' ) THEN
      CALL DYNMCS
      ELSE IF (WD(1:4).EQ.'ENER' ) THEN
      CALL PGETE(ICYCLE)
      ELSE IF (WD(1:4).EQ.'FAST' ) THEN
      CALL FNBSET('PARSE')
      ELSE IF (WD(1:4).EQ.'FLAG' ) THEN
      CALL EFLAGS('PARSE')
      ELSE IF (WD(1:4).EQ.'HBUI' ) THEN
      CALL HBUILD
      ELSE IF (WD(1:2).EQ.'IC' ) THEN
      CALL INTCOR
      ELSE IF (WD(1:3).EQ.'NCS') THEN
      CALL NCSPAR
      ELSE IF (WD(1:4).EQ.'MMDG')  THEN 
      CALL MMDG
      ELSE IF (WD(1:4).EQ.'MINI' ) THEN
      CALL MINIMI
      ELSE IF (WD(1:4).EQ.'NOE ' ) THEN
      CALL NOESET
      ELSE IF (WD(1:4).EQ.'ONEB' ) THEN
      CALL READONEBOND
      ELSE IF (WD(1:4).EQ.'PARA' ) THEN
      CALL PARRDR
      ELSE IF (WD(1:4).EQ.'PATC' ) THEN
      CALL PATSET
      ELSE IF (WD(1:4).EQ.'PICK' ) THEN
      CALL PICK(.FALSE.)
      ELSE IF (WD(1:4).EQ.'PMAG' ) THEN
      CALL READPMAG
      ELSE IF (WD(1:4).EQ.'PRIN' ) THEN
      CALL PRINT
      ELSE IF (WD(1:4).EQ.'PROT' ) THEN
      CALL READHSHIFT
      ELSE IF (WD(1:4).EQ.'PS  ' ) THEN
      CALL PS300
      ELSE IF (WD(1:4).EQ.'CPYT' ) THEN
      CALL NEXTST("Python command=",CMD)
      CALL PYTHON_INTERP(qterm,fd,CMD)	
C      DONE=.FALSE.
C      WD='    '
      ELSE IF (WD(1:4).EQ.'PYTH' ) THEN
         fd = 0
         fd = mapUnitToFD( ISTRM(nstrm) )
CCC         if (.NOT. qterm .AND. ISTRM(nstrm).NE.5) then
CCC            WRITE(6,'(A)') ' %ERR: command not available within @ files'
C the python shell command is not available when reading from
C @ files. python_interp assumes that the input comes from stdin
C This limitation could be lifted by acquiring the file descriptor associated
C with the Fortran file unit. This is a nonstandard operation:
C  IRIX: maplun     [note that maplun(unit=5) seems to fail.]
C  gcc lib: FNum
C  DEC Fortran: getfd
CCC         else
CC         end if
CC         if ( ISTRM(nstrm).EQ.5 ) then
CC            fd = 0
CC         else
CC            fd = maplun( ISTRM(nstrm) )
CC         end if
CCC         write(6,*) 'fd, unit= ' , fd, istrm(nstrm)
         CMD='    '
         WRITE(6,'(A)') '  use the function python_end() to return to xplor.'
         CALL PYTHON_INTERP(qterm,fd,CMD)
CCC      end if
      ELSE IF ((WD(1:4).EQ.'RAMA' ).OR.(WD(1:4).EQ.'CONF')) THEN
      CALL READRAMA
      ELSE IF (WD(1:4).EQ.'XRAM' ) THEN
      CALL READXRAM
      ELSE IF (WD(1:4).EQ.'ROTM' ) THEN
      CALL ROTMAN
      ELSE IF (WD(1:4).EQ.'STRU' ) THEN
      CALL PSFPRS
      ELSE IF (WD(1:4).EQ.'READ' ) THEN
      CALL READD
      ELSE IF (WD(1:4).EQ.'RELA' ) THEN
      CALL RELAX
      ELSE IF (WD(1:4).EQ.'RTF '.OR.WD(1:4).EQ.'TOPO' ) THEN
      CALL RTFRDR
      ELSE IF (WD(1:4).EQ.'SBOU' ) THEN
      CALL SBOUND
C
C TCL interpreter by JJK 
C
C See CDS's notes above about reading from @ files.
C
      ELSE IF (WD(1:4).EQ.'CTCL' ) THEN
         CALL NEXTST("TCL command=",CMD)
         CALL TCL_INTERP(1,qterm,fd,CMD)	
      ELSE IF (WD(1:4).EQ.'TCL ' ) THEN
         fd = 0
         if (.NOT. qterm .AND. ISTRM(nstrm).NE.5) then
            WRITE(6,'(A)') ' %ERR: command not available within @ files'
         else
            CMD='    '
            CALL TCL_INTERP(1,qterm,fd,CMD)	
         end if
      ELSE IF (WD(1:4).EQ.'VECT' ) THEN
      CALL VECTOR
      ELSE IF (WD(1:4).EQ.'SEGM' ) THEN
      CALL SEGMNT
      ELSE IF (WD(1:4).EQ.'SHAK' ) THEN
      CALL SHKSET
      ELSE IF (WD(1:4).EQ.'SURF' ) THEN
      CALL SURFAC
      ELSE IF (WD(1:4).EQ.'TEST' ) THEN
      CALL TESTCH
      ELSE IF (WD(1:4).EQ.'VOLU' ) THEN
      CALL VOLUME
      ELSE IF (WD(1:4).EQ.'USER' ) THEN
      CALL USERSB
C=======================================================================
            ELSE IF (WD(1:4).EQ.'CD') THEN
C     change working directory
               CALL NEXTFI('Change Directory=',NEWDIR)
               CALL CHDIR(NEWDIR)
               CALL GETCWD(CURDIR)
               DIRLEN=1
C     
               DO WHILE(CURDIR(DIRLEN:DIRLEN).GT.' ')
                  DIRLEN=DIRLEN+1
               END DO
C     
               IF(DIRLEN.GT.1) DIRLEN=DIRLEN-1
               WRITE(6,'(A)') CURDIR(1:DIRLEN)


C
      ELSE IF (WD(1:4).EQ.'WRIT' ) THEN
      CALL WRITT
      ELSE IF (WD(1:4).EQ.'XREF' ) THEN
      CALL XREFIN
      ELSE IF (WD(1:4).EQ.'TRIO' ) THEN
      CALL READTRIO
      ELSE IF (WD(1:4).EQ.'ORIE' ) THEN
      CALL READORIENT
      ELSE IF (WD(1:4).EQ.'COLL' ) THEN
      CALL READCOLLAPSE
      ELSE IF (WD(1:4).EQ.'?   ' ) THEN
      CALL SHOWAL
      ELSE IF (.NOT.QSUBSHELL .AND. (WD(1:4).EQ.'STOP'.OR.EOF) ) THEN
      DONE=.TRUE.
      ENDIND=ENDIND-1
      ELSE
      CALL CHKEND('X-PLOR>',DONE)
      IF (DONE) THEN
      IF (.NOT.QSUBSHELL) THEN
      WRITE(6,'(A)')
     &      ' %X-PLOR-ERR: "END" not allowed. "STOP" terminates program'
      DONE=.FALSE.
      END IF
      ENDIND=ENDIND+1
      END IF
      END IF
      END IF
      IF (.NOT. (DONE)) goto 300
      DONE=.FALSE.
      IF (QSUBSHELL) THEN
         ENDIND=ENDIND-1
         call FLUSH(6)
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE XPLOR_CLEANUP
      IMPLICIT NONE
      INCLUDE  'comand.fcm'
      INCLUDE  'psf.fcm'
      INCLUDE  'cnst.fcm'
      INCLUDE  'funct.fcm'
      INCLUDE  'vector.fcm'
      INCLUDE  'timer.fcm'
C =====
C local
C =====
      DOUBLE PRECISION SECS
      INTEGER I, L
      LOGICAL QOPEN, QFORM, QWRITE
      CHARACTER*9  DATE
      CHARACTER*8  TIME
C
C =================
C terminate program
C =================
C
      CALL PYTHON_QUIT()
C free ARIA lists
      CALL ARIHP(0,0,0)
C free proton chemical shift restraints list
      CALL HSHIFTSHP
C free SHAKE constraints list
      CALL SHAKHP(0)
C free dihedral angle restraints list
      CALL CDIHP(0)
C free j-coupling restraints list
      CALL COUPHP
C free carbon chemical shift restraints list
      CALL CARBHP
C free onebond j-coupling restraints list
      CALL ONEHP
      CALL PMAGHP
C free conformational database restraints list
      CALL RAMAHP
      CALL XRAMHP
C free NOE restraints list
      CALL NOEHP(0)
C
C free XREFIN atom lists, reflections, and maps
      CALL XRAREF(0)
      CALL XRAATM(0)
      CALL XRMAPR(-1)
C
C free NCS group lists
      CALL NCSFIN
C
C free PLN group lists
      CALL PLNFIN
C
C free buffer stores
      DO I=1,MAXSTO
      IF (PTRSTO(I).NE.0) CALL FREHP(PTRSTO(I),IREAL8(LENSTO(I)))
      END DO
C
C free nonbonded lists
      DO I=1,NDSMAX
      CALL RENBND(0,0,0,0,0,0,0,0,0,I)
      ENDDO
C
C free up hbonded list
      DO I=1,NDSMAX
      CALL HBALLC(0,0,I)
      ENDDO
C free double selection arrays
      CALL DSRSET('FREE')
C
C free up space for the trajectory writing facility
      CALL TRTFRE
C
C free up space for the parameter learning facility
      CALL PRTFRE
C 
C free up torsion angle stuff
      CALL TORHP(0,.TRUE.)
C
C free RELAxation matrix space
      CALL RELRES
C
C close the ps connection
      CALL PSFREE
C
C free up space for the distance geometry bounds matrices
      CALL DGRESZ(0)
C
C write info about STACK and HEAP
      if ( wrnlev.gt.0 ) then
         CALL PRISTK
         CALL PRINHP
         CALL PRIEND
      end if
C
C write info about total CPU time
      CALL VCPU(SECS)
      CALL VDATE(DATE,9,L)
      CALL VTIME(TIME,8,L)
      if ( wrnlev.gt.0 ) then
         WRITE(6,'(A,F12.4,A,/,4A,/,4A)')
     &        ' X-PLOR: total CPU time=',SECS,' s',
     &        ' X-PLOR: entry time at ',STRTIM,' ',STRDAT,
     &        ' X-PLOR: exit time at ',TIME,' ',DATE
      end if
C
C close all files
      DO I=1,99
      CALL VINQRE('UNIT',WDT,WDTMAX,WDTLEN,QOPEN,QFORM,QWRITE,I)
      IF (QOPEN) CALL VCLOSE(I,'KEEP',ERROR)
      END DO
C
C TCL interface by JJK - moved down here due to an apparent bug in 
C TCL_finalize - it calls exit(0) under Darwin!!
C
      CALL TCL_QUIT
C
      RETURN
      END
C======================================================================
      SUBROUTINE PRINT
C
C parse PRINT qualifiers
      IMPLICIT NONE
C I/O
      INCLUDE  'comand.fcm'
      INCLUDE  'psf.fcm'
      INCLUDE  'coord.fcm'
      INCLUDE  'cnst.fcm'
      INCLUDE  'heap.fcm'
      INCLUDE  'noe.fcm'
C local
      CHARACTER*4 SOBJ
      DOUBLE PRECISION THRESH
C begin
      CALL NEXTA4('PRINT-object=',SOBJ)
      IF (SOBJ.EQ.'THRE') THEN
      CALL NEXTF('THREshold=',THRESH)
      CALL NEXTA4('PRINT-object=',SOBJ)
      ELSE
      THRESH=-0.0001D0
      END IF
C
      IF (SOBJ.EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &' <print-object>:== ',
     &'    HBONds |',
     &'   [THREshold=<real>] BONDs | ANGLes | DIHEdrals | IMPRopers',
     &'   NOE | CDIH '
C-DOCUMENTATION-SOURCE-END
C
      ELSE IF (SOBJ.EQ.'HBON') THEN
      CALL HBPRIN
      ELSE IF (SOBJ.EQ.'BOND') THEN
      CALL PRPICK('BOND',THRESH)
      ELSE IF (SOBJ.EQ.'ANGL') THEN
      CALL PRPICK('ANGL',THRESH)
      ELSE IF (SOBJ.EQ.'DIHE') THEN
      CALL PRPICK('DIHE',THRESH)
      ELSE IF (SOBJ.EQ.'IMPR') THEN
      CALL PRPICK('IMPR',THRESH)
      ELSE IF (SOBJ.EQ.'NOE ') THEN
      CALL NOEPRI(THRESH,0)
      IF (NOEICV.GT.0) CALL NOEPRI(THRESH,1)
      ELSE IF (SOBJ.EQ.'CDIH') THEN
      CALL CDIPRI(PUNIT,CNPHI,CNSCA,HEAP(ICIP),HEAP(ICJP),
     &        HEAP(ICKP),HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),
     &        HEAP(ICCPE),HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),
     &        THRESH,HEAP(HPDCV),0,DIHICV)
      IF (DIHICV.GT.0) THEN
      CALL CDIPRI(PUNIT,CNPHI,CNSCA,HEAP(ICIP),HEAP(ICJP),
     &            HEAP(ICKP),HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),
     &            HEAP(ICCPE),HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),
     &            THRESH,HEAP(HPDCV),1,DIHICV)
      END IF
      ELSE
      CALL DSPERR('PRINT','unknown value')
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE READD
C
C parse READ qualifiers
      IMPLICIT NONE
C I/O
      INCLUDE  'comand.fcm'
      INCLUDE  'psf.fcm'
C begin
      CALL NEXTWD('READ-qualifier=')
C
      IF (WD(1:4).EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &'<read-object> :==',
     &' TRAJectory <read-trajectory-statement> END'
C-DOCUMENTATION-SOURCE-END
C
C read dynamics file
      ELSE IF (WD(1:4).EQ.'DYNA'.OR.WD(1:4).EQ.'TRAJ') THEN
      CALL READDP
      ELSE
      CALL DSPERR('X-PLOR','unknown qualifier')
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE WRITT
C
C parses WRITE qualifiers
      IMPLICIT NONE
C I/O
      INCLUDE  'comand.fcm'
C begin
      CALL NEXTWD('WRITE-qualifier=')
C
      IF (WD(1:4).EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &' <write-object>:==',
     &' STRUcture <write-structure-statement> END',
     &' COORdinates <write-coordinate-statement> END',
     &' PARAmeters <write-parameter-statement> END',
     &' TRAJectory <write-trajectory-statement> END'
C-DOCUMENTATION-SOURCE-END
C
C======================================================================
      ELSE IF (WD(1:3).EQ.'PSF'.OR.WD(1:4).EQ.'STRU') THEN
C
C defaults
      OFILE='OUTPUT'
C
C parsing
      CALL PUSEND('WRITe-STRUcture>')
743   CONTINUE
      CALL NEXTWD('WRITe-STRUcture>')
      IF (WD(1:4).EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &' <write-structure-statement>:==',
     &'  OUTPut=<filename> '
C-DOCUMENTATION-SOURCE-END
C
      ELSE IF (WD(1:4).EQ.'OUTP') THEN
      CALL NEXTFI('OUTPut=',OFILE)
      ELSE
      CALL CHKEND('WRITe-STRUcture>',DONE)
      END IF
      IF (.NOT. (DONE)) goto 743
      DONE=.FALSE.
C
      CALL PSFWRT(OFILE)
C======================================================================
      ELSE IF (WD(1:4).EQ.'PARA') THEN
C
C defaults
      OFILE='OUTPUT'
C
C parsing
      CALL PUSEND('WRITe-PARAmeter>')
769   CONTINUE
      CALL NEXTWD('WRITe-PARAmeter>')
      IF (WD(1:4).EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &' <write-parameter-statement>:==',
     &'  OUTPut=<filename> '
C-DOCUMENTATION-SOURCE-END
C
      ELSE IF (WD(1:4).EQ.'OUTP') THEN
      CALL NEXTFI('OUTPut=',OFILE)
      ELSE
      CALL CHKEND('WRITe-PARAmeter>',DONE)
      END IF
      IF (.NOT. (DONE)) goto 769
      DONE=.FALSE.
C
      CALL PARWTR(OFILE,'NORMAL')
C======================================================================
      ELSE IF (WD(1:4).EQ.'COOR') THEN
      CALL CWRITE
C======================================================================
      ELSE IF (WD(1:4).EQ.'TRAJ') THEN
      CALL TRTDYN
C======================================================================
      ELSE
      CALL DSPERR('WRITE','unknown qualifier')
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE MINIMI
C
C parses minimizer commands
      IMPLICIT NONE
C I/O
      INCLUDE  'comand.fcm'
C begin
      CALL NEXTWD('MINImize-qualifier=')
C
      IF (WD(1:4).EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
      WRITE(DUNIT,'(10X,A)')
     &'<minimize-statement> :==',
     &' POWEll <minimize-powell-statement>  END',
     &' RIGId  <minimize-rigid-body-statement>  END'
C-DOCUMENTATION-SOURCE-END
C
      ELSE IF (WD(1:4).EQ.'POWE') THEN
      CALL POWELL
      ELSE IF (WD(1:4).EQ.'RIGI') THEN
      CALL MRIGID
      ELSE
      CALL DSPERR('MINIMIZE','unknown qualifier')
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE SHOWAL
C
C prints pertinent information about the status of X-PLOR
      IMPLICIT NONE
C I/O
      INCLUDE  'comand.fcm'
C local
      INTEGER I
      LOGICAL QOPEN, QFORM, QWRITE
      CHARACTER*12 FORM
      CHARACTER*6  ACCESS
C begin
      CALL SHOW
C
C inquire all open files
      WRITE(6,'(A)') ' X-PLOR: list of open files:'
      DO I=1,99
      CALL VINQRE('UNIT',WDT,WDTMAX,WDTLEN,QOPEN,QFORM,QWRITE,I)
      IF (QOPEN) THEN
      IF (QFORM) THEN
      FORM=' '
      ELSE
      FORM=' unformatted'
      END IF
      IF (QWRITE) THEN
      ACCESS=' write'
      ELSE
      ACCESS=' read'
      END IF
      WRITE(6,'(9X,3A)') WDT(1:WDTLEN),ACCESS,FORM
      END IF
      END DO
      RETURN
      END
